<script setup lang="ts">
import { onMounted, ref } from 'vue'
import { promotionStore } from '@/stores/promo'
import PromotionDialog from '@/components/PromotionDialog.vue'
import http from '@/services/http'

const promoStore = promotionStore()
const search = ref('')
const items = promoStore.items
const dialog = ref(false)
const promotionToEdit = ref(null) // กำหนด promotionToEdit เป็น ref ที่นี่

const fetchPromotions = async () => {
  try {
    const response = await http.get('/promotions') // เรียกใช้งาน API ที่ให้ข้อมูลโปรโมชั่นทั้งหมด
    promoStore.setItems(response.data) // นำข้อมูลที่ได้รับมาใส่ในสโตร์
  } catch (error) {
    console.error('Error fetching promotions:', error)
  }
}

onMounted(() => {
  fetchPromotions() // เรียกใช้งานฟังก์ชัน fetchPromotions เมื่อ Component ถูกโหลด
})

const deletePromotion = async (promotion: any) => {
  try {
    const response = await http.delete(`/promotions/${promotion.id}`)
    if (response.status === 200) {
      promoStore.deletePromotion(promotion)
      console.log('Promotion deleted successfully')
    } else {
      throw new Error(`Error deleting promotion: ${response.statusText}`)
    }
  } catch (error) {
    console.error('Error deleting promotion:', error)
  }
}

const editPromotion = (promotion: any) => {
  dialog.value = true
  promotionToEdit.value = promotion
}

const handlePromotionCreated = (newPromotionData: any) => {
  // เพิ่มข้อมูลโปรโมชั่นใหม่ลงในรายการโปรโมชั่น
  promoStore.addPromotion(newPromotionData)
}
</script>

<template>
  <!-- //////// -->
  <v-card flat>
    <v-card-title class="d-flex align-center pe-2">
      <v-icon icon="mdi-sale"></v-icon> &nbsp; Promotion

      <v-spacer></v-spacer>

      <v-text-field
        v-model="search"
        density="compact"
        label="Search"
        prepend-inner-icon="mdi-magnify"
        variant="solo-filled"
        flat
        hide-details
        single-line
      ></v-text-field>

      <v-btn variant="outlined" rounded="xl" @click="dialog = !dialog"> New Promotion </v-btn>

      <v-dialog v-model="dialog" persistent width="1024">
        <v-card>
          <v-card-title>
            <span class="text-h5">Edit Promotion</span>
          </v-card-title>
          <!-- Include your Promodialog component -->

          <PromotionDialog
            :dialog="dialog"
            @closeDialog="dialog = $event"
            @promotionCreated="handlePromotionCreated"
          />
        </v-card>
      </v-dialog>
    </v-card-title>
    <v-divider></v-divider>
    <v-data-table v-model:search="search" :items="items">
      <template v-slot:[`header.status`]>
        <div class="text-end">Status</div>
      </template>

      <template v-slot:[`item.discountType`]="{ item }">
        <div size="small" readonly>
          <v-icon
            :icon="
              item.discountType === 'Cash'
                ? 'mdi-cash'
                : item.discountType === 'Percentage'
                  ? 'mdi-percent'
                  : 'mdi-bitcoin'
            "
          ></v-icon>
        </div>
      </template>

      <template v-slot:[`item.status`]="{ item }">
        <div class="text-end">
          <v-icon class="mx-2" color="primary" @click="editPromotion(item)">mdi-pencil</v-icon>
          <v-icon class="mx-2" color="error" @click="deletePromotion(item)">mdi-delete</v-icon>
          <v-chip
            :color="item.status ? 'green' : 'red'"
            :text="item.status ? 'Active' : 'Inactive'"
            class="text-uppercase"
            size="small"
            label
          ></v-chip>
        </div>
      </template>
    </v-data-table>
  </v-card>
</template>
